      SUBROUTINE DE75D(F,M,K,INIAPR,IMAX,JSTART,YX,X,IU,EPS,THRESH,     16.03.21
     1                 H,HMIN,BUL,XP,YP,MEXACT,NUMBES,DELTY,RO,MESTER,
     2                 K2,IMAX2,YX2,NATTEM,AU,AJK,AU2,AJK2,XJ0,XJ02,
     3                 AJKP,U,U2,ZFI,ZFI2,HD4I,RABC,
     4                 ALP,ALPN,CMAR,P,S,ALP2,ALPN2,CMAR2,IERR)         
C
      DOUBLE PRECISION YX,X,EPS,THRESH,H,HMIN,XP,YP,DELTY,RO,YX2,AU,AJK,
     1                 AU2,AJK2,XJ0,XJ02,AJKP,U,U2,ZFI,ZFI2,HD4I,RABC,
     2                 ALP,ALPN,CMAR,P,S,ALP2,ALPN2,CMAR2
C
      DOUBLE PRECISION KSI,WC1,WC2,WC3,HD2,HD4,HOLD,WC30,WC12,WC22,WC32
      DOUBLE PRECISION ROMAX,W,DZETA
C
      LOGICAL BUL,BULH,BULQ
C
      DIMENSION YX (M),XJ0 (K) ,AU (M,1),AJK (M,1),HD4I(1),RABC(K2),
     1          YX2(M),XJ02(K2),AU2(M,1),AJK2(M,1),YP(M),AJKP(M,1),
     2          ALP(K),  ALPN(K),  CMAR(K,K),   P(1), S(1), U(M,K),
     3          ALP2(K2),ALPN2(K2),CMAR2(K2,K2),U2(M,K2),
     4          DELTY(M),RO(M),ZFI(M,1),ZFI2(M,1)
      DIMENSION NUMBES(MEXACT)
C
      COMMON/COM70D/WC1,WC2,WC3,LASN,HD2,HD4,HOLD
      COMMON/COM75D/LASN0,LASN2,WC30,WC12,WC22,WC32
C
      COMMON/STAT76/NACCEP,NREJEC
C
      EXTERNAL F
C
      IERR=0
      BULH=.FALSE.
      BULQ=.FALSE.
      ICOUNT=0
      KP1=K+1
      KP2=K+2
      K2P1=K2+1
      K2P2=K2+2
      XP=X
      DO 45 L=1,M
   45 YP(L)=YX(L)
      IF (JSTART .NE. 0) GO TO 55
C  
C       THE FIRST STEP REALIZATION
C       CALCULATION OF ALL VARIABLES DEPENDING ON K
C  
      CALL DE75DK(K,RABC,ALP,ALPN,CMAR,P,S,K2,ALP2,ALPN2,CMAR2)
C  
C       CALCULATION OF ALL VARIABLES DEPENDING ON H
C       AND ALSO VARIABLES DEPENDING ON H AND K
C  
      CALL DE70DH(K2,H,HD4I)
      DO 50 J=1,K
   50 XJ0(J)=XP+ALP(J)*H
      CALL DE75D1(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI)
      GO TO 110
C
C       THE NEXT STEP REALIZATION
C
   55 DO 60 J=1,K
   60 XJ0(J)=XP+ALP(J)*H
C       CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP ARE STORED
      DO 70 J=1,KP1
      DO 65 L=1,M
   65 AJKP(L,J)=AJK(L,J)
   70 CONTINUE
C
      IF (H .EQ. HOLD) GO TO 80
C       RECALCULATION OF ALL VARIABLS DEPENDING ON H
      CALL DE70DH(K2,H,HD4I)
C 
   80 IF (INIAPR .NE. 1) GO TO 85
C       CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS
      CALL DE75D1(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI)
      GO TO 110
C       CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS
C       AJK FROM PREVIOUS STEP
   85 IF (H .EQ. HOLD) GO TO 90
      KSI=H/HOLD
      CALL DE71DE(M,K,P,AJK,KSI,ZFI(1,KP2))
      GO TO 95
   90 CALL DE71DF(M,K,S,AJK,ZFI(1,KP2))
C
   95 IF (BULQ) GO TO 110
      CALL F(XP,YP,ZFI(1,K+4),M)
      DO 100 L=1,M
  100 ZFI(L,1)=ZFI(L,K+4)*WC2
C
  110 IEXIT=0
      DO 120 NU=1,IMAX
      CALL DE70DI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI)
  120 CONTINUE 
      IEXIT=3
      CALL DE70DI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI)
      CALL DE70DF(M,KP1,AU,YX)
C                                                                       
C------  CALCULATION OF THE SECOND SOLUTION OF (K2+1) ORDER   ----------
C                                                                       |
      DO 125 J=1,K2                                                     |
      CALL DE70DC(M,KP1,ALPN2(J),AU,U2(1,J),ZFI(1,KP2))                 |
  125 CONTINUE                                                          |
      DO 130 J=1,K2                                                     |
      XJ02(J)=XP+ALP2(J)*H                                              |
      CALL F(XJ02(J),U2(1,J),ZFI2(1,J+1),M)                              |
  130 CONTINUE                                                          |
C                                                                       |
      IF (BULQ) GO TO 145                                               |
C                                                                       |
C    CALCULATION OF CONSTANT PARTIAL IN MARKOV QUADRATURE FOR K=K2      |
C                                                                       |
      DO 140 L=1,M                                                      |
  140 ZFI2(L,1)=ZFI(L,K+4)*WC22                                         |
C                                                                       |
  145 WC3=WC32                                                          |
      LASN=LASN2                                                        |
      CALL DE70DQ(M,K2,ZFI2,CMAR2,AJK2)                                 |
      IEXIT=0                                                           |
      DO 150 NU=1,IMAX2                                                 |
      CALL DE70DI(F,M,K2,IEXIT,YP,XJ02,AJK2,HD4I,RABC,ALPN2,CMAR2,AU2,  |
     1            U2,ZFI2)                                              |
  150 CONTINUE                                                          |
      IEXIT=3                                                           |
      CALL DE70DI(F,M,K2,IEXIT,YP,XJ02,AJK2,HD4I,RABC,ALPN2,CMAR2,AU2,  |
     1            U2,ZFI2)                                              |
      CALL DE70DF(M,K2P1,AU2,YX2)                                       |
      WC3=WC30                                                          |
      LASN=LASN0                                                        |


C                                                                       |
C-----------------------------------------------------------------------
C
      GO TO (155,185),MESTER                     
C                                                
C-------- CALCULATION OF ABSOLUTE ERROR --------------------------------
C                                                                       |
  155 DO 160 L=1,M                                                      |
      DELTY(L)=YX2(L)-YX(L)                                             |
  160 RO(L)=DELTY(L)                                                    |
C                                                                       |
C-----------------------------------------------------------------------
      GO TO (205,165,175),IU
C
C-------- CALCULATION OF RELATIVE ERROR
C        
  165 DO 170 L=1,M
      IF (YX(L) .EQ. 0.D0) GO TO 170
      RO(L)=DELTY(L)/ABS(YX(L))
  170 CONTINUE
      GO TO 205
C
C-------- CALCULATION OF MEASURE ERROR
C
  175 DO 180 L=1,M
      IF ( ABS(YX(L)) .LT. THRESH )GO TO 180
      RO(L)=DELTY(L)/ABS(YX(L))      
  180 CONTINUE
      GO TO 205
C
C-------- CALCULATION OF ESTIMATE OF ABSOLUTE ERROR --------------------
C                                                                       |
  185 DO 200 L=1,M                                                      |
      W=0.5D0*(ABS(AU2(L,1)-AU(L,1)))                                   |
      DO 190 J=2,KP2                                                    |
  190 W=W  +   ABS(AU2(L,J)-AU(L,J))                                    |
      DO 195 J=KP2+1,K2P2                                               |
  195 W=W+ABS(AU2(L,J))                                                 |
      DELTY(L)=W                                                        |
  200 RO(L)=DELTY(L)                                                    |
C-----------------------------------------------------------------------
C
      CALL DE75DE(M,K,IU,THRESH,DELTY,YX,U,RO)
C
C-------- CALCULATION OF NORM ERROR
C
  205 CALL DE75DN(M,MEXACT,NUMBES,RO,ROMAX)
      IF (ROMAX .EQ. 0.D0) GO TO 210
      DZETA=EXP(LOG(EPS/ROMAX)/DBLE(KP2))
      GO TO 215
  210 DZETA=10.D0
  215 IF (ROMAX .LE. EPS) GO TO 270
C-----------------------------------------------------------------------
C                                                                       |
C------ THE ACCURACY IS NOT ACHIEVED                                    |
C                                                                       | 
C      STATISTICS
      NREJEC=NREJEC+1
C
      IF (BULH) GO TO 310                                               |  
      H=0.9D0*H*DZETA                                                   |   
      BUL=.FALSE.                                                       |    
      IF (ABS(H) .GT. ABS(HMIN)) GO TO 225                              |    
      H=SIGN(HMIN,H)                                                    |
      BULH=.TRUE.                                                       |
C                                                                       |
C---------  PREPARATION TO REPEAT CALCULATION OF TWO SOLUTIONS YX AND YX2
C               IN NEW ELEMENTARY SEGMENT                               |
C                                                                       |
  225 IF  (ICOUNT .EQ. NATTEM) GO TO 345                                |
      ICOUNT=ICOUNT+1                                                   |
      BULQ=.TRUE.                                                       |
  230 DO 235 J=1,K                                                      |
  235 XJ0(J)=XP+ALP(J)*H                                                |
C                                                                       |
C--------RECALCULATION OF ALL VARIABLES DEPEDING ON H                   |
C                                                                       |
      CALL DE70DH(K2,H,HD4I)                                            |
C                                                                       |
      IF (INIAPR .NE. 1  .AND.  JSTART .EQ. 1) GO TO 240                21.02.20
      CALL DE75D0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI)               |
      GO TO 110                                                         |
C                                                                       |
  240 DO 250 J=1,KP1                                                    |
      DO 245 L=1,M                                                      |
  245 AJK(L,J)=AJKP(L,J)                                                |
  250 CONTINUE                                                          |
      GO TO 85                                                          |
C-----------------------------------------------------------------------
C
C........................................................................
C                                                                       .
C------ THE ACCURACY IS ACHIEVED                                        .
C                                                                       .
  270 X=XP+H                                                            .
      HOLD=H                                                            .
C
C       STATISTICS
      NACCEP=NACCEP+1     
C                                                                       .
C----------FORMATION OF ANSWERS                                         .
C                                                                       .
      DO 290 J=1,KP1                                                    .
      DO 285 L=1,M                                                      .
      AJK(L,J)=AJK2(L,J)                                                .
  285 AU (L,J)=AU2 (L,J)                                                .
  290 CONTINUE                                                          .
C                                                                       .
      DO 295 L=1,M                                                      .
      YX(L)=YX2(L)                                                      .
  295 AU(L,KP2)=AU2(L,KP2)                                              .
C                                                                       .
      H=0.9D0*H*DZETA                                                   .
      GO TO 380                                                         .
C........................................................................
  310 IERR=65
      GO TO 370
  345 IERR=66
  370 CALL UTDE75(IERR,75)
  380 JSTART=1
      RETURN
      END                            
